# **********************************************************************
#
# Copyright (c) 2000
# Object Oriented Concepts, Inc.
# Billerica, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

# ----------------------------------------------------------------------
# Use the following lines to set your installation directories
# ----------------------------------------------------------------------

prefix		= C:\OOC
bindir		= $(prefix)\bin
libdir		= $(prefix)\lib
includedir	= $(prefix)\include
idldir		= $(prefix)\idl

# ----------------------------------------------------------------------
# Either define OPTIMIZE_SPEED as "yes" to build with speed
# optimization turned on, or define OPTIMIZE_SIZE as "yes" to optimize
# for size, or define DEBUG as "yes" to build with debug
# information. Note that all these settings are mutual exclusive.
#
# NOTE: If you change this option later, you need to completely
# rebuild this distribution. (Using "nmake /f Makefile.mak clean", and 
# "nmake /f Makefile.mak" after that.)
# ----------------------------------------------------------------------

#OPTIMIZE_SPEED=yes
#OPTIMIZE_SIZE=yes
#DEBUG=yes

# ----------------------------------------------------------------------
# Define OLD_IOSTREAM as "yes" if you want to use the old iostream
# library, i.e., if you want to use '#include <iostream.h>" instead of
# "#include <iostream>". 
#
# NOTE: If you want to check your application with "purify", please
# use the old iostream library instead of the new one. If the new one
# is used, purify will detect lots of non-existent memory problems.
# ----------------------------------------------------------------------

#OLD_IOSTREAM=yes

# ----------------------------------------------------------------------
# If you want to make use of a Dynamic Link Library (DLL) instead of a
# static library in the packages where this is supported, uncomment
# the following line to define DLL as "yes". Note that in this case
# you need "perl" for the compilation process.
#
# NOTE: If you want to compile ORBacus with JThreads/C++ support as
# a DLL, you must also compile JThreads/C++ as a DLL.  When using
# the DLL version of ORBacus or JThreads/C++, you must not specify a 
# statically linked runtime library with the /MT, /MTd, /ML or /MLd 
# compiler flags. 
# ----------------------------------------------------------------------

#DLL=yes

# ----------------------------------------------------------------------
# If you want to compile ORBacus with JThreads/C++ support, uncomment 
# the following line to define WITH_JTC as "yes".
#
# NOTE: JThreads/C++ is required for the Event Service and the
# IMR. JThreads/C++ is a separate software package, and must be
# installed before ORBacus.
# ----------------------------------------------------------------------

#WITH_JTC=yes

# ----------------------------------------------------------------------
# If JThreads/C++ support is enabled, use the following line to set
# the JThreads/C++ installation path.
# ----------------------------------------------------------------------

JTC_DIR=$(prefix)

# ----------------------------------------------------------------------
# Experts only: You can modify the lines below, for example to change
# the settings for code optimizations.
# ----------------------------------------------------------------------

#
# These options are for building with optimizations turned on.  See
# Microsoft's compiler documentation for more information on the /O
# flag. Please note that debug information is automatically disabled by
# the Microsoft compiler when optimization is enabled.
#

!if "$(OPTIMIZE_SPEED)" == "yes"

OPT_CXXFLAGS	= /Ox 
OPT_LINKFLAGS	=
OPT_CPPFLAGS	= /DNDEBUG

!endif

!if "$(OPTIMIZE_SIZE)" == "yes"

OPT_CXXFLAGS	= /O1 
OPT_LINKFLAGS	=
OPT_CPPFLAGS	= /DNDEBUG

!endif

!if "$(DEBUG)" == "yes"

#
# These options are for building with debug information, and no
# optimization.
#

OPT_CXXFLAGS	= /Zi $(OPT_CXXFLAGS)
OPT_LINKFLAGS	= /debug $(OPT_LINKFLAGS)
OPT_CPPFLAGS	= $(OPT_CPPFLAGS)
LIBSUFFIX	= $(LIBSUFFIX)d
CXX_RTL		= /MDd

!else

CXX_RTL		= /MD

!endif

CXX		= cl.exe
CXXFLAGS	= /nologo $(CXX_RTL) /W3 /GX /Gy $(OPT_CXXFLAGS)
CXXCPP		= cl.exe /nologo /E
CPPFLAGS	    = /DWIN32 $(OPT_CPPFLAGS) # /DOB_CLEAR_MEM
LIBS		= 
GUILIBS		= 
DLLLIBS		=
LINK	= link.exe
LINKFLAGS	= /nologo $(OPT_LINKFLAGS) /subsystem:console /incremental:no
LINKGUIFLAGS	= /nologo $(OPT_LINKFLAGS) /subsystem:windows /incremental:no
LINKDLLFLAGS	= /nologo $(OPT_LINKFLAGS) /dll /incremental:no
AR		= lib.exe
ARFLAGS		= /nologo

SHELL		= bash # Only needed for "nmake /f Makefile.mak test"

# ----------------------------------------------------------------------
# Don't change anything below this line
# ----------------------------------------------------------------------

!ifndef INCLUDE
!error The INCLUDE environment variable needs to be set.
!endif
!ifndef LIB
!error The LIB environment variable needs to be set.
!endif

EVERYTHING	= all install min install_min test clean

.SUFFIXES:
.SUFFIXES:	.cc .cpp .obj

!ifdef NMAKE_NO_BATCH_MODE
.cpp.obj:
	$(CXX) /c $(ALL_CPPFLAGS) $(ALL_CXXFLAGS) $<

.cc.obj:
	$(CXX) /c $(ALL_CPPFLAGS) $(ALL_CXXFLAGS) /TP $<
!else
.cpp.obj::
	$(CXX) /c $(ALL_CPPFLAGS) $(ALL_CXXFLAGS) $<

.cc.obj::
	$(CXX) /c $(ALL_CPPFLAGS) $(ALL_CXXFLAGS) /TP $<
!endif

all:: $(TARGETS)

install::

min::

install_min::

test::

clean::
	-@del *.obj *.bak *.flc *.pdb *.pch

!if "$(TARGETS)" != ""
clean::
	@for %i in ( $(TARGETS) ) do \
	    @if exist %i del %i 
!endif

!if "$(PDB_FILES)" != ""
clean::
	@for %i in ( $(PDB_FILES) ) do \
	    @if exist %i del %i 
!endif

install::

test::

lib:
	mkdir $@

bin:
	mkdir $@
