dnl **********************************************************************
dnl
dnl Copyright (c) 1999
dnl Object Oriented Concepts, Inc.
dnl Billerica, MA, USA
dnl
dnl All Rights Reserved
dnl
dnl **********************************************************************

dnl ----------------------------------------------------------------------
dnl ORBacus-specific configuration
dnl ----------------------------------------------------------------------

AC_SUBST(OBE_CPPFLAGS)
AC_SUBST(OBE_LDFLAGS)
AC_SUBST(OBE_IDLFLAGS)
AC_SUBST(OBE_LIBS)
AC_SUBST(OBE_LIBVER)
AC_SUBST(IDL)

OBE_CPPFLAGS=
OBE_LDFLAGS=
OBE_IDLFLAGS=
OBE_LIBS=
OBE_LIBVER=
IDL=

obe_path="../obe/"
if test -f include/OBE/CORBA.h
then
    obe_path=""
fi
if test -n "$with_obe" -a "$with_obe" != "no" -a "$with_obe" != "yes"
then
    obe_path="${with_obe}/"
    if test ! -f ${obe_path}include/OBE/CORBA.h
    then
        obe_path="${obe_path}obe/"
    fi
fi
if test ! -f ${obe_path}include/OBE/CORBA.h
then
    AC_MSG_ERROR(Can't find ORBacus! Use the --with-obe=path option.)
fi
obe_ver=""
if test "$LIBEXT" != ".a"
then
    obe_ver=`grep '#define OB_VERSION' \
        < ${obe_path}include/OBE/Basic.h | sed -e 's/^.* \"//' -e 's/\"$//'`
    OBE_LIBVER=".${obe_ver}"
fi
if test ! \( -n "$with_obe" -a "$with_obe" != "no" -a "$with_obe" != "yes" \)
then
    obe_path="\$(top_srcdir)/$obe_path"
fi

OBE_LDFLAGS="$OBE_LDFLAGS -L${obe_path}lib"
OBE_CPPFLAGS="$OBE_CPPFLAGS -I${obe_path}include"
OBE_IDLFLAGS="$OBE_IDLFLAGS -I${obe_path}idl --embedded"
OBE_LIBS="$OBE_LIBS -lOBE"
IDL="${obe_path}../ob/bin/idl"

AC_SUBST(WITH_JTC)
AC_SUBST(JTC_LIBVER)
WITH_JTC=no
JTC_LIBVER=
AC_ARG_WITH(jtc,
  --with-jtc                make use of JThreads/C++,
builtin(include,../config/threads.m4)
jtc_path="../jtc/"
if test -f include/JTC/Thread.h
then
    jtc_path=""
fi
if test -n "$with_jtc" -a "$with_jtc" != "no" -a "$with_jtc" != "yes"
then
    jtc_path="${with_jtc}/"
    if test ! -f ${jtc_path}include/JTC/Thread.h
    then
	jtc_path="${jtc_path}jtc/"
    fi	
fi
if test ! -f ${jtc_path}include/JTC/Thread.h
then
    AC_MSG_ERROR(Can't find JThreads/C++! Use the --with-jtc=path option.)
fi
if test ! \( -n "$with_jtc" -a "$with_jtc" != "no" -a "$with_jtc" != "yes" \)
then
    jtc_path="\$(top_srcdir)/$jtc_path"
fi
OBE_LDFLAGS="$OBE_LDFLAGS -L${jtc_path}lib"
OBE_CPPFLAGS="$OBE_CPPFLAGS -I${jtc_path}include"
OBE_LIBS="$OBE_LIBS -lJTC"
AC_DEFINE(HAVE_JTC)
WITH_JTC=yes
)
