// **********************************************************************
//
// Copyright (c) 1999
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef CHAIN_IMPL_H
#define CHAIN_IMPL_H

#include <time.h>

#include <Chain_skel.h>

class Link_impl : public POA_Link,
		  public PortableServer::RefCountServantBase
{
    CORBA::ORB_var orb_; // The ORB
    CORBA::String_var file_;  // File containing the IOR of the next link
    Link_var next_;     // Next link
    bool master_;       // Am I the master link in the chain
    long nextId_;       // Next message ID

    timeval startTime_;  // Time of the start of the forward operation
    
public:

    Link_impl(CORBA::ORB_ptr, const char*);

    virtual void forward(const Link::Message&)
        throw(CORBA::SystemException);

    virtual void send(CORBA::Long, CORBA::Long)
        throw(CORBA::SystemException);

    virtual void close_loop()
        throw(CORBA::SystemException);
};

#endif // CHAIN_IMPL_H
