// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef BROADCASTER_IMPL_H
#define BROADCASTER_IMPL_H

#include <BroadcasterAdmin_impl.h>

namespace chat 
{

class Broadcaster_impl : public POA_chat::Broadcaster,
			 public PortableServer::RefCountServantBase
{
    //
    // The administrative object
    //
    BroadcasterAdmin_impl* admin_;

    //
    // Internal administrative identifier
    //
    CORBA::ULong id_;

public:

    //
    // Construction/Destruction
    //
    Broadcaster_impl(BroadcasterAdmin_impl* admin, CORBA::ULong id);
    ~Broadcaster_impl();

    //
    // Operations from the .idl file
    //

    virtual void say(const char*)
	throw(CORBA::SystemException);

    virtual void setNickName(const char* nick)
        throw(NickExists, CORBA::SystemException);

    virtual void getReceiverByNick(const char*, ReceiverDesc_out)
        throw(UnknownNick, CORBA::SystemException);

    virtual StringSeq* getReceiverNames()
        throw(CORBA::SystemException);

    virtual void unsubscribe()
        throw(CORBA::SystemException);

}; // class Broadcaster


} // namespace chat

#endif
