// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef _RILogger_h_
#define _RILogger_h_

//
// Forward declarations
//
class CORBA_OUT;

//
// Request interceptor logger base class
//
class RILogger
{
protected:

    //
    // Service context identifiers
    //
    const IOP::ServiceId REQUEST_CONTEXT_ID;
    const IOP::ServiceId REPLY_CONTEXT_ID;

    //
    // Used to display CORBA::Any
    //
    CORBA_OUT* out_;

    //
    // Used to encode/decode the call stack information so that
    // it can be used as the service context
    //
    IOP::Codec_var cdrCodec_;

    //
    // My slot id
    //
    PortableInterceptor::SlotId mySlotId_;

    //
    // Convert CORBA::Octet to string
    //
    char* getOctet(CORBA::Octet);

    //
    // Display PortableInterceptor::RequestInfo
    //
    void displayRequestInfo(PortableInterceptor::RequestInfo_ptr,
			    CORBA::Short);

public:

    RILogger(PortableInterceptor::ORBInitInfo_ptr,
	     PortableInterceptor::SlotId);
    virtual ~RILogger();

    //
    // Register the Request Interceptor loggers
    //
    static void init();
};

#endif
