// **********************************************************************
//
// Copyright (c) 1999
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_OBJECT_FWD_H
#define OB_OBJECT_FWD_H

#include <OB/Template.h>

namespace CORBA
{
    
class Object;
typedef Object* Object_ptr;
typedef Object_ptr ObjectRef;

} // End of namespace CORBA

namespace OB
{

class ObjectFactory;
typedef ObjectFactory* ObjectFactory_ptr;

} // End of namespace OB

void OBDuplicate(CORBA::Object_ptr);
void OBRelease(CORBA::Object_ptr);

void OBDuplicate(OB::ObjectFactory_ptr);
void OBRelease(OB::ObjectFactory_ptr);

namespace CORBA
{
    
typedef OB::ObjVar< Object > Object_var;
typedef OB::ObjOut< Object > Object_out;

} // End of namespace CORBA

namespace OB
{

typedef OB::ObjVar< ObjectFactory > ObjectFactory_var;
typedef OB::ObjOut< ObjectFactory > ObjectFactory_out;

} // End of namespace OB

#endif
