// **********************************************************************
//
// Generated by the ORBacus IDL-to-C++ Translator
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

// Version: 4.0.4

#ifndef __OB_Policy_h__
#define __OB_Policy_h__

#ifndef OB_IMPORT
#   ifdef OB_DLL
#      define OB_IMPORT __declspec(dllimport)
#   else
#      define OB_IMPORT /**/
#   endif
#endif


#include <OB/Policy_fwd.h>

#ifndef OB_INTEGER_VERSION
#   error No ORBacus version defined!
#endif

#ifndef OB_NO_VERSION_CHECK
#   if (OB_INTEGER_VERSION != 4000400L)
#       error ORBacus version mismatch!
#   endif
#endif

//
// IDL:omg.org/CORBA:1.0
//
namespace CORBA
{

//
// IDL:omg.org/CORBA/PolicyType:1.0
//
typedef CORBA::ULong PolicyType;
typedef CORBA::ULong_out PolicyType_out;

//
// IDL:omg.org/CORBA/PolicyTypeSeq:1.0
//
class OBUnique_PolicyTypeSeq { };

typedef OB::FixSeq< CORBA::ULong, OBUnique_PolicyTypeSeq > PolicyTypeSeq;
typedef OB::SeqVar< OB::FixSeq< CORBA::ULong, OBUnique_PolicyTypeSeq > > PolicyTypeSeq_var;
typedef OB::SeqOut< OB::FixSeq< CORBA::ULong, OBUnique_PolicyTypeSeq > > PolicyTypeSeq_out;

//
// IDL:omg.org/CORBA/Policy:1.0
//
// Locality constrained
//
class Policy : public CORBA::Object
{
    Policy(const Policy&);
    void operator=(const Policy&);

    static OB_IMPORT const char* ids_[];

public:

    Policy() { }

    typedef Policy_ptr _ptr_type;
    typedef Policy_var _var_type;

    static inline Policy_ptr
    _duplicate(Policy_ptr p)
    {
        if(p)
            p -> _OB_incRef();
        return p;
    }

    static inline Policy_ptr
    _nil()
    {
        return 0;
    }

    static Policy_ptr _narrow(CORBA::Object_ptr);
    static Policy_ptr _narrow(CORBA::AbstractBase_ptr);

    virtual const char** _OB_ids() const;
    static const char** _OB_staticIds();

    virtual bool _OB_isLC() const { return true; };

    //
    // IDL:omg.org/CORBA/Policy/policy_type:1.0
    //
    virtual PolicyType policy_type() = 0;

    //
    // IDL:omg.org/CORBA/Policy/copy:1.0
    //
    virtual Policy_ptr copy() = 0;

    //
    // IDL:omg.org/CORBA/Policy/destroy:1.0
    //
    virtual void destroy() = 0;
};

//
// IDL:omg.org/CORBA/PolicyList:1.0
//
class OBUnique_PolicyList { };

typedef OB::ObjSeq< Policy, OBUnique_PolicyList > PolicyList;
typedef OB::SeqVar< OB::ObjSeq< Policy, OBUnique_PolicyList > > PolicyList_var;
typedef OB::SeqOut< OB::ObjSeq< Policy, OBUnique_PolicyList > > PolicyList_out;

//
// IDL:omg.org/CORBA/PolicyErrorCode:1.0
//
typedef CORBA::Short PolicyErrorCode;
typedef CORBA::Short_out PolicyErrorCode_out;

//
// IDL:omg.org/CORBA/BAD_POLICY:1.0
//
const PolicyErrorCode BAD_POLICY = 0;

//
// IDL:omg.org/CORBA/UNSUPPORTED_POLICY:1.0
//
const PolicyErrorCode UNSUPPORTED_POLICY = 1;

//
// IDL:omg.org/CORBA/BAD_POLICY_TYPE:1.0
//
const PolicyErrorCode BAD_POLICY_TYPE = 2;

//
// IDL:omg.org/CORBA/BAD_POLICY_VALUE:1.0
//
const PolicyErrorCode BAD_POLICY_VALUE = 3;

//
// IDL:omg.org/CORBA/UNSUPPORTED_POLICY_VALUE:1.0
//
const PolicyErrorCode UNSUPPORTED_POLICY_VALUE = 4;

//
// IDL:omg.org/CORBA/PolicyError:1.0
//
struct PolicyError : public CORBA::UserException
{
#ifdef OB_CLEAR_MEM
    PolicyError();
#else
    PolicyError() { }
#endif
    PolicyError(const PolicyError&);
    PolicyError& operator=(const PolicyError&);

    static PolicyError* _downcast(CORBA::Exception*);
    static const PolicyError* _downcast(const CORBA::Exception*);
    virtual const char* _name() const;
    virtual void _raise() const { throw *this; }
    virtual const char* _rep_id() const;
    virtual char* _to_string() const;

    virtual CORBA::Exception* _OB_clone() const;
    virtual void _OB_insertInAny(CORBA::Any&);

    PolicyErrorCode reason;

    PolicyError(PolicyErrorCode);
};

//
// IDL:omg.org/CORBA/PolicyManager:1.0
//
// Locality constrained
//
class PolicyManager : public CORBA::Object
{
    PolicyManager(const PolicyManager&);
    void operator=(const PolicyManager&);

    static OB_IMPORT const char* ids_[];

public:

    PolicyManager() { }

    typedef PolicyManager_ptr _ptr_type;
    typedef PolicyManager_var _var_type;

    static inline PolicyManager_ptr
    _duplicate(PolicyManager_ptr p)
    {
        if(p)
            p -> _OB_incRef();
        return p;
    }

    static inline PolicyManager_ptr
    _nil()
    {
        return 0;
    }

    static PolicyManager_ptr _narrow(CORBA::Object_ptr);
    static PolicyManager_ptr _narrow(CORBA::AbstractBase_ptr);

    virtual const char** _OB_ids() const;
    static const char** _OB_staticIds();

    virtual bool _OB_isLC() const { return true; };

    //
    // IDL:omg.org/CORBA/PolicyManager/InvalidPolicies:1.0
    //
    struct InvalidPolicies : public CORBA::UserException
    {
        InvalidPolicies() { }
        InvalidPolicies(const InvalidPolicies&);
        InvalidPolicies& operator=(const InvalidPolicies&);

        static InvalidPolicies* _downcast(CORBA::Exception*);
        static const InvalidPolicies* _downcast(const CORBA::Exception*);
        virtual const char* _name() const;
        virtual void _raise() const { throw *this; }
        virtual const char* _rep_id() const;
        virtual char* _to_string() const;

        virtual CORBA::Exception* _OB_clone() const;
        virtual void _OB_insertInAny(CORBA::Any&);

        class OBUnique_indices { };
#ifdef HAVE_VCPLUSPLUS_BUGS
        typedef OB::FixSeq< CORBA::UShort, OBUnique_indices > _indices_seq;
#else
        typedef OB::FixSeq< CORBA::UShort, OBUnique_indices > _indices_seq;
#endif
        _indices_seq indices;

        InvalidPolicies(const OB::FixSeq< CORBA::UShort, OBUnique_indices >&);
    };

    //
    // IDL:omg.org/CORBA/PolicyManager/get_policy_override:1.0
    //
    virtual Policy_ptr get_policy_override(PolicyType t) = 0;

    //
    // IDL:omg.org/CORBA/PolicyManager/get_specific_policy_overrides:1.0
    //
    virtual PolicyList* get_specific_policy_overrides(const PolicyTypeSeq& ts) = 0;

    //
    // IDL:omg.org/CORBA/PolicyManager/get_all_policy_overrides:1.0
    //
    virtual PolicyList* get_all_policy_overrides() = 0;

    //
    // IDL:omg.org/CORBA/PolicyManager/add_policy_overrides:1.0
    //
    virtual void add_policy_overrides(const PolicyList& policies) = 0;

    //
    // IDL:omg.org/CORBA/PolicyManager/remove_policy_overrides:1.0
    //
    virtual void remove_policy_overrides(const PolicyTypeSeq& ts) = 0;

    //
    // IDL:omg.org/CORBA/PolicyManager/replace_all_policy_overrides:1.0
    //
    virtual void replace_all_policy_overrides(const PolicyList& policies) = 0;
};

} // End of namespace CORBA

//
// IDL:omg.org/CORBA:1.0
//
namespace OBV_CORBA
{

} // End of namespace OBV_CORBA

//
// IDL:omg.org/CORBA/Policy:1.0
//
namespace CORBA
{

inline void
release(CORBA::Policy_ptr p)
{
    if(p)
        p -> _OB_decRef();
}

inline Boolean
is_nil(CORBA::Policy_ptr p)
{
    return p == 0;
}

} // End of namespace CORBA

//
// IDL:omg.org/CORBA/PolicyManager:1.0
//
namespace CORBA
{

inline void
release(CORBA::PolicyManager_ptr p)
{
    if(p)
        p -> _OB_decRef();
}

inline Boolean
is_nil(CORBA::PolicyManager_ptr p)
{
    return p == 0;
}

} // End of namespace CORBA

#endif
