// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef ACTIVE_STATE_FACTORY_IMPL_H
#define ACTIVE_STATE_FACTORY_IMPL_H

#include <OB/IMR_skel.h>

#include <IMRLogger_fwd.h>

namespace IMR
{

//
// Forward declarations
//
class OADDatabase;
class InternalServer_impl;
class ServerDatabase;
class ServerStarter;

class ActiveStateFactory_impl : public POA_IMR::ActiveStateFactory
{
    ServerDatabase* db_;
    PortableServer::POA_var activeStatePOA_;
    PortableServer::POA_var poa_;
    InternalServer_impl* server_;

    ActiveState_ptr createActiveStateReference(CORBA::Long);

public:

    ActiveStateFactory_impl(ServerDatabase*,
                            OADDatabase*,
                            CORBA::ORB_ptr,
                            PortableServer::POA_ptr,
                            PortableServer::POA_ptr,
		            IMROAD::Logger_ptr,
			    ServerStarter*);
    ~ActiveStateFactory_impl();

    //
    // Standard IDL to C++ Mapping
    //

    //
    // Mapping for IMR::ActiveStateFactory
    //
    virtual ActiveState_ptr get_active_state(const char* server)
	throw(NoSuchServer, CORBA::SystemException);

    virtual PortableServer::POA_ptr _default_POA();
};

}; // End namespace IMR

#endif
