// **********************************************************************
//
// Copyright (c) 1999
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/IMR.h>

#include <ServerObserver_impl.h>

using namespace IMR;

// ----------------------------------------------------------------------
// ServerObserver_impl constructor/destructor implementation
// ----------------------------------------------------------------------

ServerObserver_impl::ServerObserver_impl(
    PortableServer::POA_ptr poa,
    ActiveStateFactory_ptr factory)
    : poa_(PortableServer::POA::_duplicate(poa)),
      factory_(ActiveStateFactory::_duplicate(factory))
{
}

ServerObserver_impl::~ServerObserver_impl()
{
}

// ----------------------------------------------------------------------
// ServerObserver_impl public member implementation
// ----------------------------------------------------------------------

//
// IDL:ooc.com/IMR/ServerObserver/server_died:1.0
//
void
ServerObserver_impl::server_died(const char* server,
				 const char* id)
    throw(CORBA::SystemException)
{
    try
    {
	ActiveState_var s = factory_ -> get_active_state(server);
	s -> set_status(id, STOPPED);
    }
    catch(const CORBA::OBJECT_NOT_EXIST&)
    {
    }
}

PortableServer::POA_ptr
ServerObserver_impl::_default_POA()
{
    return PortableServer::POA::_duplicate(poa_);
}
