// **********************************************************************
//
// Copyright (c) 1999
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <ServerDatabase.h>

using namespace IMR;

// ----------------------------------------------------------------------
// External, non-inline duplicate/release for templates
// ----------------------------------------------------------------------

void
OBDuplicate(ServerRecord_ptr p)
{
    if(p)
        p -> _OB_incRef();
}

void
OBRelease(ServerRecord_ptr p)
{
    if(p)
        p -> _OB_decRef();
}

// ----------------------------------------------------------------------
// ServerRecord constructor/destructor implementation
// ----------------------------------------------------------------------

ServerRecord::ServerRecord(ServerDatabase* db,
			   const IMRDB_4_0_2::ServerStatusRecord* rec)
    : db_(db),
      rec_(*rec),
      destroyed_(false)
{
}

ServerRecord::~ServerRecord()
{
}

// ----------------------------------------------------------------------
// ServerRecord public member implementation
// ----------------------------------------------------------------------

IMRDB_4_0_2::ServerStatusRecord&
ServerRecord::record()
{
    if(destroyed_)
        throw CORBA::OBJECT_NOT_EXIST();

    return rec_;
}
