// **********************************************************************
//
// Copyright (c) 1999
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_CODEC_FACTORY_IMPL_H
#define OB_CODEC_FACTORY_IMPL_H

#include <OB/Object.h>
#include <OB/Except.h>
#include <OB/Codec.h>

namespace IOP
{

//
// Codec::Factory. This factory provides a method of retrieving a
// Codec for converting IDL described data into an OctetSeq.
//
class CodecFactory_impl : public CodecFactory
{
    Codec_var cdrCodec_; // Cached CDR Codec
#ifdef HAVE_JTC
    JTCMutex cdrCodecMut_;
#endif
    
    OB::ORBInstance_var orbInstance_; // The ORBInstance
    
public:

    ~CodecFactory_impl();

    //
    // IDL to C++ Mapping
    //
    Codec_ptr create_codec(const Encoding&);

    //
    // ORBacus internal functions
    // Application programs must not use these functions directly
    //
    
    //
    // Set the ORBInstance object
    //
    void _OB_setORBInstance(OB::ORBInstance_ptr);
};

} // End namespace IOP

#endif
