// **********************************************************************
//
// Copyright (c) 1999
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_GIOP_SERVER_WORKER_FWD_H
#define OB_GIOP_SERVER_WORKER_FWD_H

#include <OB/Template.h>

namespace OB
{

class GIOPUpcall;
typedef GIOPUpcall* GIOPUpcall_ptr;

class GIOPServerWorker;
typedef GIOPServerWorker* GIOPServerWorker_ptr;

class GIOPServerWorkerReactive;
typedef GIOPServerWorkerReactive* GIOPServerWorkerReactive_ptr;

#ifdef HAVE_JTC

class GIOPServerWorkerThreaded;
typedef GIOPServerWorkerThreaded* GIOPServerWorkerThreaded_ptr;

#endif

} // End of namespace OB

void OBDuplicate(OB::GIOPServerWorker_ptr);
void OBRelease(OB::GIOPServerWorker_ptr);

//  void OBDuplicate(OB::GIOPServerWorkerReactive_ptr);
//  void OBRelease(OB::GIOPServerWorkerReactive_ptr);

#ifdef HAVE_JTC

void OBDuplicate(OB::GIOPServerWorkerThreaded_ptr);
void OBRelease(OB::GIOPServerWorkerThreaded_ptr);

#endif

namespace OB
{

typedef ObjVar< GIOPServerWorker > GIOPServerWorker_var;
typedef ObjSeq< GIOPServerWorker, int > GIOPServerWorkerSeq;

//  typedef ObjVar< GIOPServerWorkerReactive > GIOPServerWorkerReactive_var;

#ifdef HAVE_JTC

typedef ObjVar< GIOPServerWorkerThreaded > GIOPServerWorkerThreaded_var;

#endif

} // End of namespace OB

#endif
