// **********************************************************************
//
// Copyright (c) 1999
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_IMR_ACTIVE_STATE_HOLDER_H
#define OB_IMR_ACTIVE_STATE_HOLDER_H

#include <OB/IMRState_fwd.h>

namespace OB
{

class IMRActiveStateHolder OB_COLON_MUTEX
{
    //
    // Hide copy constructor and assignment operator
    //
    IMRActiveStateHolder(const IMRActiveStateHolder&);
    void operator=(const IMRActiveStateHolder&);

    IMR::ActiveState_var activeState_; // The IMR ActiveState

    CORBA::String_var serverName_;
    CORBA::String_var serverInstance_;
    bool running_;

public:

    IMRActiveStateHolder(const char*, const char*);

    void setActiveState(IMR::ActiveState_ptr);
    IMR::ActiveState_ptr getActiveState() const;

    void serverRunning(OB::ORBInstance_ptr);
};

} // End of namespace OB

#endif
