// **********************************************************************
//
// Copyright (c) 1999
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <Logger_impl.h>

using namespace CORBA;
using namespace OB;

// ----------------------------------------------------------------------
// Logger_impl private method implementation
// ----------------------------------------------------------------------

void
Logger_impl::message(const char* msg)
{
    OB_SYNCHRONIZED

    OB_CERR << msg << OB_ENDL;
}

// ----------------------------------------------------------------------
// Logger_impl constructor/destructor
// ----------------------------------------------------------------------

Logger_impl::Logger_impl()
{
}

Logger_impl::~Logger_impl()
{
}

// ----------------------------------------------------------------------
// Logger_impl public member implementation
// ----------------------------------------------------------------------

void
Logger_impl::info(const char* msg)
{
    message(msg);
}

void
Logger_impl::error(const char* msg)
{
    const char* head = "error: ";
    String_var s = string_alloc(strlen(head) + strlen(msg));
    strcpy(s.inout(), head);
    strcat(s.inout(), msg);
    message(s);
}

void
Logger_impl::warning(const char* msg)
{
    const char* head = "warning: ";
    String_var s = string_alloc(strlen(head) + strlen(msg));
    strcpy(s.inout(), head);
    strcat(s.inout(), msg);
    message(s);
}

void
Logger_impl::trace(const char* category, const char* msg)
{
    String_var s = (const char*)"[ ";
    s += category;
    s += ": ";
    const char* p = msg;
    const char* next;
    while((next = strchr((char*)p, '\n')))
    {
	next++;
	String_var line = string_alloc(next - p);
	strncpy(line.inout(), p, next - p);
	line[next - p] = '\0';
	s += line;
	s += "  ";
	p = next;
    }
    s += p;
    s += " ]";
    message(s);
}
