# **********************************************************************
#
# Copyright (c) 2000
# Object Oriented Concepts, Inc.
# Billerica, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

NAME		= $(top_srcdir)\lib\ob$(LIBSUFFIX).lib
PDB_NAME	= $(top_srcdir)\lib\ob$(LIBSUFFIX).pdb

TARGETS		= $(NAME)

PDB_FILES     = $(PDB_NAME)

!include $(top_srcdir)\config\Make.rules.mak

HDIR		= $(top_srcdir)\include\OB
TDIR		= ..\translator
IMRDIR		= ..\imr

OBJS		= Basic.obj \
		  Hashtable.obj \
		  Fixed.obj \
		  CompletionStatus.obj \
		  Except.obj \
		  Any.obj \
		  TCKind.obj \
		  TypeCode.obj \
		  Context.obj \
		  Principal.obj \
		  RefCounted.obj \
		  IOP.obj \
		  Object.obj \
		  StubImpl.obj \
		  MarshalStubImpl.obj \
		  Policy.obj \
		  OBPolicies.obj \
		  OBPolicies_impl.obj \
		  ORBPolicyManager_impl.obj \
		  Custom.obj \
		  Types.obj \
		  Custom_impl.obj \
		  StringValue.obj \
		  IFR1.obj \
		  IFR2.obj \
		  IFR3.obj \
		  IFR4.obj \
		  IMRTypes.obj \
		  IMRState.obj \
		  OADProcessEndpoint.obj \
		  OADProcessEndpoint_skel.obj \
		  OADProcessEndpoint_impl.obj \
		  ValueBase.obj \
		  ValueFactoryBase.obj \
		  AbstractBase.obj \
		  ORBPolicyFactory.obj \
		  ORBInstance.obj \
		  TypeCodeFactory.obj \
		  InitialServiceManager.obj \
		  ValueFactoryManager.obj \
		  ORBControl.obj \
		  OBORB.obj \
		  ORB_impl.obj \
		  ORB_init.obj \
		  ServiceInfo.obj \
		  TimeBase.obj \
		  Messaging.obj \
		  Messaging_impl.obj \
		  Dynamic.obj \
		  Codec.obj \
		  CodecFactory_impl.obj \
		  PICommon.obj \
		  PIRequest.obj \
		  PIClient.obj \
		  PIServer.obj \
		  PIPolicy.obj \
		  PIIOR.obj \
		  PIORBInit.obj \
		  OBORBInit.obj \
		  PICurrent.obj \
		  PI.obj \
		  PIManager.obj \
		  PICurrent_impl.obj \
		  PIRequest_impl.obj \
		  PIClient_impl.obj \
		  PIServer_impl.obj \
		  PIArgStrategy.obj \
		  OBORBInitInfo_impl.obj \
		  PolicyFactoryManager.obj \
		  Dispatch.obj \
		  Dispatch_impl.obj \
		  DispatchRequest_impl.obj \
		  PortableServer.obj \
		  POAInterface.obj \
		  OBPOAInterface.obj \
		  POACommon.obj \
		  POAStrategy.obj \
		  IDStrategy.obj \
		  POAControl.obj \
		  POA_impl.obj \
		  PortableServerGlobal.obj \
		  ObjectKey.obj \
		  POAAdapterActivator.obj \
		  POAAdapterActivator_skel.obj \
		  POAServantManager.obj \
		  POAServantManager_skel.obj \
		  POACurrent.obj \
		  POACurrent_impl.obj \
		  POAManager.obj \
		  OBPOAManager.obj \
		  IMRActiveStateHolder.obj \
		  POAManagerFactory_impl.obj \
		  POAManager_impl.obj \
		  POALocator.obj \
		  POAOAInterface_impl.obj \
		  POAPolicies.obj \
		  POAPolicyType.obj \
		  OBPOAPolicyType.obj \
		  OBPOAPolicies.obj \
		  POAPolicies_impl.obj \
		  POAServantActivator.obj \
		  POAServantActivator_skel.obj \
		  POAServantLocator.obj \
		  POAServantLocator_skel.obj \
		  POAServantBase.obj \
		  DirectStubImpl.obj \
		  NamedValue.obj \
		  Environment.obj \
		  Bounds.obj \
		  WrongTransaction.obj \
		  MultiRequestSender.obj \
		  DII.obj \
		  DSI.obj \
		  Current.obj \
		  DynamicAny.obj \
		  DynamicAny_impl.obj \
		  Timer.obj \
		  EventHandlerBase.obj \
		  Reactor.obj \
		  SelectReactor.obj \
		  Client.obj \
		  CollocatedClient.obj \
		  CollocatedServer.obj \
		  GIOPClient.obj \
		  GIOPClientWorker.obj \
		  Downcall.obj \
		  Server.obj \
		  GIOPServer.obj \
		  GIOPServerStarter.obj \
		  GIOPServerWorker.obj \
		  Upcall.obj \
		  GIOP.obj \
		  GIOPMessage.obj \
		  IIOP.obj \
		  CoreTraceLevels.obj \
		  CONV_FRAME.obj \
		  CodeSetDatabase.obj \
		  CodeSetDatabaseInit.obj \
		  CharMapDatabaseInit.obj \
		  CodeSetUtil.obj \
		  CodeConverter.obj \
		  OCIBuffer.obj \
		  OCITypes.obj \
		  OCI.obj \
		  OCI_impl.obj \
		  OCI_IIOP.obj \
		  OCI_IIOP_impl.obj \
		  IIOPConfig.obj \
		  Net.obj \
		  Properties.obj \
		  INS.obj \
		  Logger.obj \
		  Logger_impl.obj \
		  Stream.obj \
		  ValueReaderWriter.obj \
		  NTService.obj \
                  CorbaURL.obj \
		  BootManager.obj \
		  BootManager_impl.obj \
		  ObjectIdHasher.obj \
		  WinReactor.obj

# Also in non-DLL mode needed for the clean target
DEF_NAME	= ob$(LIBSUFFIX).def
DLL_NAME	= $(top_srcdir)\lib\ob$(OB_LIBVER)$(LIBSUFFIX).dll
EXP_NAME	= $(top_srcdir)\lib\ob$(LIBSUFFIX).exp

ALL_IDLFLAGS	= $(OB_IDLFLAGS) -DOB_CPLUSPLUS --this-header-dir OB \
		  --dll-import OB_IMPORT


!if "$(DLL)" == "yes"

ALL_CXXFLAGS	= $(CXXFLAGS)
ALL_CPPFLAGS	= /DOB_BUILD_DLL /I. $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_DLLLIBS	= $(OB_DLLLIBS) $(DLLLIBS)

$(NAME): $(DLL_NAME)

$(DEF_NAME):

$(DLL_NAME): $(OBJS) $(DEF_NAME)
	perl $(top_srcdir)\..\config\makedef.pl $(DEF_NAME) \
	OB$(OB_LIBVER)$(LIBSUFFIX) $(OBJS)
	$(LINK) $(LINKDLLFLAGS) /BASE:0x64000000 /def:$(DEF_NAME) \
	/IMPLIB:$(NAME) /out:$@ $(OBJS) $(ALL_DLLLIBS)

!else

ALL_CXXFLAGS	= $(CXXFLAGS) /Fd$(PDB_NAME)
ALL_CPPFLAGS	= /I. $(OB_CPPFLAGS) $(CPPFLAGS)

$(NAME): $(OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(OBJS)

!endif

$(top_srcdir)\include\OB\WinConfig.h: $(top_srcdir)\..\config\WinConfig.h
	copy $(top_srcdir)\..\config\WinConfig.h $@

$(top_srcdir)\include\OB\Config.h: $(top_srcdir)\include\OB\WinConfig.h \
				   $(top_srcdir)\..\config\Make.rules.mak
	if exist $@ del $@
!if "$(WITH_JTC)" == "yes"
	echo #define HAVE_JTC 1 >> $@
!else
	echo /* #undef HAVE_JTC */ >> $@
!endif
!if "$(DLL)" == "yes"
	echo #define OB_DLL 1 >> $@
!else
	echo /* #undef OB_DLL */ >> $@
!endif
!if "$(OLD_IOSTREAM)" != "yes"
	echo #define HAVE_IOSTREAM 1 >> $@
!else
	echo /* #undef HAVE_IOSTREAM */ >> $@
!endif
	echo #include "WinConfig.h" >> $@

clean::
	-del $(top_srcdir)\include\OB\Config.h


all:: $(HDIR)\orb.h
$(HDIR)/orb.h: \
		$(IDLDIR)/OB/orb.idl
	if exist $(IDL) \
	    del orb.cpp & \
	    del $(HDIR)\orb.h & \
	    $(IDL) $(ALL_IDLFLAGS) --no-skeletons \
	    $(IDLDIR)\OB\orb.idl & \
	    move orb.h $(HDIR) & \
	    del orb.cpp

CompletionStatus.cpp $(HDIR)/CompletionStatus.h: \
		$(IDLDIR)/OB/CompletionStatus.idl
	if exist $(IDL) \
	    del CompletionStatus.cpp & \
	    del $(HDIR)\CompletionStatus.h & \
	    $(IDL) $(ALL_IDLFLAGS) --no-skeletons \
	    $(IDLDIR)\OB\CompletionStatus.idl & \
	    move CompletionStatus.h $(HDIR)

TCKind.cpp $(HDIR)/TCKind.h: \
		$(IDLDIR)/OB/TCKind.idl
	if exist $(IDL) \
	    del TCKind.cpp & \
	    del $(HDIR)\TCKind.h & \
	    $(IDL) $(ALL_IDLFLAGS) --no-skeletons \
	    $(IDLDIR)\OB\TCKind.idl & \
	    move TCKind.h $(HDIR)

Custom.cpp $(HDIR)/Custom.h $(HDIR)/Custom_fwd.h: \
		$(IDLDIR)/OB/Custom.idl
	if exist $(IDL) \
	    del Custom.cpp & \
	    del $(HDIR)\Custom_fwd.h & \
	    del $(HDIR)\Custom.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --no-type-codes --no-skeletons \
	    $(IDLDIR)\OB\Custom.idl & \
	    move Custom_fwd.h $(HDIR) & \
	    move Custom.h $(HDIR)

Types.cpp $(HDIR)/Types.h: \
		$(IDLDIR)/OB/Types.idl
	if exist $(IDL) \
	    del Types.cpp & \
	    del $(HDIR)\Types.h & \
	    del Types_skel.cpp & \
	    del $(HDIR)\Types_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) $(IDLDIR)\OB\Types.idl & \
	    move Types.h $(HDIR) & \
	    move Types_skel.h $(HDIR) & \
	    del Types_skel.cpp

Native.cpp $(HDIR)/Native.h: \
		$(IDLDIR)/OB/Native.idl
	if exist $(IDL) \
	    del Native.cpp & \
	    del $(HDIR)\Native.h & \
	    del Native_skel.cpp & \
	    del $(HDIR)\Native_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) $(IDLDIR)\OB\Native.idl & \
	    move Native.h $(HDIR) & \
	    move Native_skel.h $(HDIR) & \
	    del Native.cpp & \
	    del Native_skel.cpp

StringValue.cpp $(HDIR)/StringValue.h $(HDIR)/StringValue_fwd.h: \
		$(IDLDIR)/OB/StringValue.idl
	if exist $(IDL) \
	    del StringValue.cpp & \
	    del $(HDIR)\StringValue_fwd.h & \
	    del $(HDIR)\StringValue.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --no-skeletons \
	    $(IDLDIR)\OB\StringValue.idl & \
	    move StringValue_fwd.h $(HDIR) & \
	    move StringValue.h $(HDIR)

Bounds.cpp $(HDIR)/Bounds.h: \
		$(IDLDIR)/OB/Bounds.idl
	if exist $(IDL) \
	    del Bounds.cpp & \
	    del $(HDIR)\Bounds.h & \
	    $(IDL) $(ALL_IDLFLAGS) --no-skeletons \
	    $(IDLDIR)\OB\Bounds.idl & \
	    move Bounds.h $(HDIR)

WrongTransaction.cpp $(HDIR)/WrongTransaction.h: \
		$(IDLDIR)/OB/WrongTransaction.idl
	if exist $(IDL) \
	    del WrongTransaction.cpp & \
	    del $(HDIR)\WrongTransaction.h & \
	    $(IDL) $(ALL_IDLFLAGS) --no-skeletons \
	    $(IDLDIR)\OB\WrongTransaction.idl & \
	    move WrongTransaction.h $(HDIR)

Logger.cpp $(HDIR)/Logger.h: \
		$(IDLDIR)/OB/Logger.idl
	if exist $(IDL) \
	    del Logger.cpp & \
	    del $(HDIR)\Logger_fwd.h & \
	    del $(HDIR)\Logger.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    --no-virtual-inheritance \
	    $(IDLDIR)\OB\Logger.idl & \
	    move Logger_fwd.h $(HDIR) & \
	    move Logger.h $(HDIR)

Reactor.cpp $(HDIR)/Reactor.h: \
		$(IDLDIR)/OB/Reactor.idl
	if exist $(IDL) \
	    del Reactor.cpp & \
	    del $(HDIR)\Reactor_fwd.h & \
	    del $(HDIR)\Reactor.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    --no-virtual-inheritance \
	    $(IDLDIR)\OB\Reactor.idl & \
	    move Reactor_fwd.h $(HDIR) & \
	    move Reactor.h $(HDIR)

OBORB.cpp $(HDIR)/OBORB.h: \
		$(IDLDIR)/OB/OBORB.idl
	if exist $(IDL) \
	    del OBORB.cpp & \
	    del $(HDIR)\OBORB_fwd.h & \
	    del $(HDIR)\OBORB.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    --no-virtual-inheritance \
	    $(IDLDIR)\OB\OBORB.idl & \
	    move OBORB_fwd.h $(HDIR) & \
	    move OBORB.h $(HDIR)

IFR1.cpp $(HDIR)/IFR1.h $(HDIR)/IFR1_fwd.h: \
		$(IDLDIR)/OB/IFR1.idl
	if exist $(IDL) \
	    del IFR1.cpp & \
	    del $(HDIR)\IFR1_fwd.h & \
	    del $(HDIR)\IFR1.h & \
	    del $(TDIR)\IFR1_skel.cpp & \
	    del $(HDIR)\IFR1_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd $(IDLDIR)\OB\IFR1.idl & \
	    move IFR1_fwd.h $(HDIR) & \
	    move IFR1.h $(HDIR) & \
	    move IFR1_skel.h $(HDIR) & \
	    move IFR1_skel.cpp $(TDIR)

IFR2.cpp $(HDIR)/IFR2.h $(HDIR)/IFR2_fwd.h: \
		$(IDLDIR)/OB/IFR2.idl
	if exist $(IDL) \
	    del IFR2.cpp & \
	    del $(HDIR)\IFR2_fwd.h & \
	    del $(HDIR)\IFR2.h & \
	    del $(TDIR)\IFR2_skel.cpp & \
	    del $(HDIR)\IFR2_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd \
	    $(IDLDIR)\OB\IFR2.idl & \
	    move IFR2_fwd.h $(HDIR) & \
	    move IFR2.h $(HDIR) & \
	    move IFR2_skel.h $(HDIR) & \
	    move IFR2_skel.cpp $(TDIR)

IFR3.cpp $(HDIR)/IFR3.h $(HDIR)/IFR3_fwd.h: \
		$(IDLDIR)/OB/IFR3.idl
	if exist $(IDL) \
	    del IFR3.cpp & \
	    del $(HDIR)\IFR3_fwd.h & \
	    del $(HDIR)\IFR3.h & \
	    del $(TDIR)\IFR3_skel.cpp & \
	    del $(HDIR)\IFR3_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd \
	    $(IDLDIR)\OB\IFR3.idl & \
	    move IFR3_fwd.h $(HDIR) & \
	    move IFR3.h $(HDIR) & \
	    move IFR3_skel.h $(HDIR) & \
	    move IFR3_skel.cpp $(TDIR)

IFR4.cpp $(HDIR)/IFR4.h $(HDIR)/IFR4_fwd.h: \
		$(IDLDIR)/OB/IFR4.idl
	if exist $(IDL) \
	    del IFR4.cpp & \
	    del $(HDIR)\IFR4_fwd.h & \
	    del $(HDIR)\IFR4.h & \
	    del $(TDIR)\IFR4_skel.cpp & \
	    del $(HDIR)\IFR4_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd $(IDLDIR)\OB\IFR4.idl & \
	    move IFR4_fwd.h $(HDIR) & \
	    move IFR4.h $(HDIR) & \
	    move IFR4_skel.h $(HDIR) & \
	    move IFR4_skel.cpp $(TDIR)


$(HDIR)/IFR.h $(HDIR)/IFR_fwd.h: \
		$(IDLDIR)/OB/IFR.idl
	if exist $(IDL) \
	    del IFR.cpp & \
	    del $(HDIR)\IFR_fwd.h & \
	    del $(HDIR)\IFR.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --no-skeletons \
	    $(IDLDIR)\OB\IFR.idl & \
	    move IFR_fwd.h $(HDIR) & \
	    move IFR.h $(HDIR) & \
	    del IFR.cpp

# We need this here, otherwise IFR.h is not rebuilt because it is not
# needed by the sources in this directory
all:: $(HDIR)/IFR.h $(HDIR)/IFR_fwd.h

IOP.cpp $(HDIR)/IOP.h: \
		$(IDLDIR)/OB/IOP.idl
	if exist $(IDL) \
	    del IOP.cpp & \
	    del $(HDIR)\IOP.h & \
	    del IOP_skel.cpp & \
	    del $(HDIR)\IOP_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) --no-type-codes $(IDLDIR)\OB\IOP.idl & \
	    move IOP.h $(HDIR) & \
	    move IOP_skel.h $(HDIR) & \
	    del IOP_skel.cpp

GIOP.cpp $(HDIR)/GIOP.h: \
		$(IDLDIR)/OB/GIOP.idl
	if exist $(IDL) \
	    del GIOP.cpp & \
	    del $(HDIR)\GIOP.h & \
	    $(IDL) $(ALL_IDLFLAGS) --locality-constrained \
	    $(IDLDIR)\OB\GIOP.idl & \
	    move GIOP.h $(HDIR)

IIOP.cpp $(HDIR)/IIOP.h: \
		$(IDLDIR)/OB/IIOP.idl
	if exist $(IDL) \
	    del IIOP.cpp & \
	    del $(HDIR)\IIOP.h & \
	    $(IDL) $(ALL_IDLFLAGS) --no-type-codes --no-skeletons \
	    $(IDLDIR)\OB\IIOP.idl & \
	    move IIOP.h $(HDIR)

CONV_FRAME.cpp $(HDIR)/CONV_FRAME.h: \
		$(IDLDIR)/OB/CONV_FRAME.idl
	if exist $(IDL) \
	    del CONV_FRAME.cpp & \
	    del $(HDIR)\CONV_FRAME.h & \
	    $(IDL) $(ALL_IDLFLAGS) --no-skeletons $(IDLDIR)\OB\CONV_FRAME.idl & \
	    move CONV_FRAME.h $(HDIR)

DynamicAny.cpp $(HDIR)/DynamicAny.h $(HDIR)/DynamicAny_fwd.h: \
		$(IDLDIR)/OB/DynamicAny.idl
	if exist $(IDL) \
	    del DynamicAny.cpp & \
	    del $(HDIR)\DynamicAny_fwd.h & \
	    del $(HDIR)\DynamicAny.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\DynamicAny.idl & \
	    move DynamicAny_fwd.h $(HDIR) & \
	    move DynamicAny.h $(HDIR)

Current.cpp $(HDIR)/Current.h $(HDIR)/Current_fwd.h: \
		$(IDLDIR)/OB/Current.idl
	if exist $(IDL) \
	    del Current.cpp & \
	    del $(HDIR)\Current_fwd.h & \
	    del $(HDIR)\Current.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\Current.idl & \
	    move Current_fwd.h $(HDIR) & \
	    move Current.h $(HDIR)

Policy.cpp $(HDIR)/Policy.h $(HDIR)/Policy_fwd.h: \
		$(IDLDIR)/OB/Policy.idl
	if exist $(IDL) \
	    del Policy.cpp & \
	    del $(HDIR)\Policy_fwd.h & \
	    del $(HDIR)\Policy.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    --no-virtual-inheritance $(IDLDIR)\OB\Policy.idl & \
	    move Policy_fwd.h $(HDIR) & \
	    move Policy.h $(HDIR)

PolicyManager.cpp $(HDIR)/PolicyManager.h $(HDIR)/PolicyManager_fwd.h: \
		$(IDLDIR)/OB/PolicyManager.idl
	if exist $(IDL) \
	    del PolicyManager.cpp & \
	    del $(HDIR)\PolicyManager_fwd.h & \
	    del $(HDIR)\PolicyManager.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    --no-virtual-inheritance $(IDLDIR)\OB\PolicyManager.idl & \
	    move PolicyManager_fwd.h $(HDIR) & \
	    move PolicyManager.h $(HDIR)

OBPolicies.cpp $(HDIR)/OBPolicies.h $(HDIR)/OBPolicies_fwd.h: \
		$(IDLDIR)/OB/OBPolicies.idl
	if exist $(IDL) \
	    del OBPolicies.cpp & \
	    del $(HDIR)\OBPolicies_fwd.h & \
	    del $(HDIR)\OBPolicies.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    --no-virtual-inheritance $(IDLDIR)\OB\OBPolicies.idl & \
	    move OBPolicies_fwd.h $(HDIR) & \
	    move OBPolicies.h $(HDIR)

POACommon.cpp $(HDIR)/POACommon.h $(HDIR)/POACommon_fwd.h: \
		$(IDLDIR)/OB/POACommon.idl
	if exist $(IDL) \
	    del POACommon.cpp & \
	    del $(HDIR)\POACommon_fwd.h & \
	    del $(HDIR)\POACommon.h & \
	    del POACommon_skel.cpp & \
	    del $(HDIR)\POACommon_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd \
	    $(IDLDIR)\OB\POACommon.idl & \
	    move POACommon_fwd.h $(HDIR) & \
	    move POACommon.h $(HDIR) & \
	    move POACommon_skel.h $(HDIR)

PortableServer.cpp $(HDIR)/PortableServer.h $(HDIR)/PortableServer_fwd.h: \
		$(IDLDIR)/OB/PortableServer.idl
	if exist $(IDL) \
	    del PortableServer.cpp & \
	    del $(HDIR)\PortableServer_fwd.h & \
	    del $(HDIR)\PortableServer.h & \
	    del PortableServer_skel.cpp & \
	    del $(HDIR)\PortableServer_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd $(IDLDIR)\OB\PortableServer.idl & \
	    move PortableServer_fwd.h $(HDIR) & \
	    move PortableServer.h $(HDIR) & \
	    move PortableServer_skel.h $(HDIR)

POAInterface.cpp $(HDIR)/POAInterface.h $(HDIR)/POAInterface_fwd.h: \
		$(IDLDIR)/OB/POAInterface.idl
	if exist $(IDL) \
	    del POAInterface.cpp & \
	    del $(HDIR)\POAInterface_fwd.h & \
	    del $(HDIR)\POAInterface.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    --no-virtual-inheritance $(IDLDIR)\OB\POAInterface.idl & \
	    move POAInterface_fwd.h $(HDIR) & \
	    move POAInterface.h $(HDIR)

OBPOAInterface.cpp $(HDIR)/OBPOAInterface.h $(HDIR)/OBPOAInterface_fwd.h: \
		$(IDLDIR)/OB/OBPOAInterface.idl
	if exist $(IDL) \
	    del OBPOAInterface.cpp & \
	    del $(HDIR)\OBPOAInterface_fwd.h & \
	    del $(HDIR)\OBPOAInterface.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    --no-virtual-inheritance $(IDLDIR)\OB\OBPOAInterface.idl & \
	    move OBPOAInterface_fwd.h $(HDIR) & \
	    move OBPOAInterface.h $(HDIR) 

POAAdapterActivator.cpp $(HDIR)/POAAdapterActivator.h \
$(HDIR)/POAAdapterActivator_fwd.h: \
		$(IDLDIR)/OB/POAAdapterActivator.idl
	if exist $(IDL) \
	    del POAAdapterActivator.cpp & \
	    del POAAdapterActivator_skel.cpp & \
	    del $(HDIR)\POAAdapterActivator_fwd.h & \
	    del $(HDIR)\POAAdapterActivator.h & \
	    del $(HDIR)\POAAdapterActivator_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd \
	    $(IDLDIR)\OB\POAAdapterActivator.idl & \
	    move POAAdapterActivator_fwd.h $(HDIR) & \
	    move POAAdapterActivator.h $(HDIR) & \
	    move POAAdapterActivator_skel.h $(HDIR)

POACurrent.cpp $(HDIR)/POACurrent.h $(HDIR)/POACurrent_fwd.h: \
		$(IDLDIR)/OB/POACurrent.idl
	if exist $(IDL) \
	    del POACurrent.cpp & \
	    del $(HDIR)\POACurrent_fwd.h & \
	    del $(HDIR)\POACurrent.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	   $(IDLDIR)\OB\POACurrent.idl & \
	    move POACurrent_fwd.h $(HDIR) & \
	    move POACurrent.h $(HDIR)

POAPolicies.cpp $(HDIR)/POAPolicies.h $(HDIR)/POAPolicies_fwd.h: \
		$(IDLDIR)/OB/POAPolicies.idl
	if exist $(IDL) \
	    del POAPolicies.cpp & \
	    del $(HDIR)\POAPolicies_fwd.h & \
	    del $(HDIR)\POAPolicies.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    --no-virtual-inheritance $(IDLDIR)\OB\POAPolicies.idl & \
	    move POAPolicies_fwd.h $(HDIR) & \
	    move POAPolicies.h $(HDIR)

POAPolicyType.cpp $(HDIR)/POAPolicyType.h : \
		$(IDLDIR)/OB/POAPolicyType.idl
	if exist $(IDL) \
	    del POAPolicyType.cpp & \
	    del $(HDIR)\POAPolicyType.h & \
	    $(IDL) $(ALL_IDLFLAGS) --no-skeletons \
	    $(IDLDIR)\OB\POAPolicyType.idl & \
	    move POAPolicyType.h $(HDIR)

OBPOAPolicyType.cpp $(HDIR)/OBPOAPolicyType.h : \
		$(IDLDIR)/OB/OBPOAPolicyType.idl
	if exist $(IDL) \
	    del OBPOAPolicyType.cpp & \
	    del $(HDIR)\OBPOAPolicyType.h & \
	    $(IDL) $(ALL_IDLFLAGS) --no-skeletons \
	    $(IDLDIR)\OB\OBPOAPolicyType.idl & \
	    move OBPOAPolicyType.h $(HDIR)

OBPOAPolicies.cpp $(HDIR)/OBPOAPolicies.h $(HDIR)/OBPOAPolicies_fwd.h: \
		$(IDLDIR)/OB/OBPOAPolicies.idl
	if exist $(IDL) \
	    del OBPOAPolicies.cpp & \
	    del $(HDIR)\OBPOAPolicies_fwd.h & \
	    del $(HDIR)\OBPOAPolicies.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    --no-virtual-inheritance $(IDLDIR)\OB\OBPOAPolicies.idl & \
	    move OBPOAPolicies_fwd.h $(HDIR) & \
	    move OBPOAPolicies.h $(HDIR)

POAManager.cpp $(HDIR)/POAManager.h $(HDIR)/POAManager_fwd.h: \
		$(IDLDIR)/OB/POAManager.idl
	if exist $(IDL) \
	    del POAManager.cpp & \
	    del $(HDIR)\POAManager_fwd.h & \
	    del $(HDIR)\POAManager.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    --no-virtual-inheritance $(IDLDIR)\OB\POAManager.idl & \
	    move POAManager_fwd.h $(HDIR) & \
	    move POAManager.h $(HDIR)

OBPOAManager.cpp $(HDIR)/OBPOAManager.h $(HDIR)/OBPOAManager_fwd.h: \
		$(IDLDIR)/OB/OBPOAManager.idl
	if exist $(IDL) \
	    del OBPOAManager.cpp & \
	    del $(HDIR)\OBPOAManager_fwd.h & \
	    del $(HDIR)\OBPOAManager.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    --no-virtual-inheritance \
	    $(IDLDIR)\OB\OBPOAManager.idl & \
	    move OBPOAManager_fwd.h $(HDIR) & \
	    move OBPOAManager.h $(HDIR)

POAServantManager.cpp $(HDIR)/POAServantManager.h \
$(HDIR)/POAServantManager_fwd.h: \
		$(IDLDIR)/OB/POAServantManager.idl
	if exist $(IDL) \
	    del POAServantManager.cpp & \
	    del POAServantManager_skel.cpp& \
	    del $(HDIR)\POAServantManager_fwd.h& \
	    del $(HDIR)\POAServantManager.h& \
	    del $(HDIR)\POAServantManager_skel.h& \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --no-orb-mediation \
	    $(IDLDIR)\OB\POAServantManager.idl & \
	    move POAServantManager_fwd.h $(HDIR) & \
	    move POAServantManager.h $(HDIR) & \
	    move POAServantManager_skel.h $(HDIR)

POAServantActivator.cpp $(HDIR)/POAServantActivator.h \
$(HDIR)/POAServantActivator_fwd.h: \
		$(IDLDIR)/OB/POAServantActivator.idl
	if exist $(IDL) \
	    del POAServantActivator.cpp & \
	    del $(HDIR)\POAServantActivator_fwd.h & \
	    del $(HDIR)\POAServantActivator.h & \
	    del POAServantActivator_skel.cpp &\
	    del $(HDIR)\POAServantActivator_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --no-orb-mediation \
	    $(IDLDIR)\OB\POAServantActivator.idl & \
	    move POAServantActivator_fwd.h $(HDIR) & \
	    move POAServantActivator.h $(HDIR) & \
	    move POAServantActivator_skel.h $(HDIR)

POAServantLocator.cpp $(HDIR)/POAServantLocator.h \
$(HDIR)/POAServantLocator_fwd.h: \
		$(IDLDIR)/OB/POAServantLocator.idl
	if exist $(IDL) \
	    del POAServantLocator.cpp & \
	    del $(HDIR)\POAServantLocator_fwd.h & \
	    del $(HDIR)\POAServantLocator.h & \
	    del POAServantLocator_skel.cpp & \
	    del $(HDIR)\POAServantLocator_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --no-orb-mediation \
	    $(IDLDIR)\OB\POAServantLocator.idl & \
	    move POAServantLocator_fwd.h $(HDIR) & \
	    move POAServantLocator.h $(HDIR) & \
	    move POAServantLocator_skel.h $(HDIR)

OCITypes.cpp $(HDIR)/OCITypes.h: \
		$(IDLDIR)/OB/OCITypes.idl
	if exist $(IDL) \
	    del OCITypes.cpp & \
	    del $(HDIR)\OCITypes.h & \
	    $(IDL) $(ALL_IDLFLAGS) $(IDLDIR)\OB\OCITypes.idl & \
	    move OCITypes.h $(HDIR)

OCI.cpp $(HDIR)/OCI.h $(HDIR)/OCI_fwd.h: \
		$(IDLDIR)/OB/OCI.idl
	if exist $(IDL) \
	    del OCI.cpp & \
	    del $(HDIR)\OCI_fwd.h & \
	    del $(HDIR)\OCI.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    --no-virtual-inheritance $(IDLDIR)\OB\OCI.idl & \
	    move OCI_fwd.h $(HDIR) & \
	    move OCI.h $(HDIR)

OCI_IIOP.cpp $(HDIR)/OCI_IIOP.h $(HDIR)/OCI_IIOP_fwd.h: \
		$(IDLDIR)/OB/OCI_IIOP.idl
	if exist $(IDL) \
	    del OCI_IIOP.cpp & \
	    del $(HDIR)\OCI_IIOP_fwd.h & \
	    del $(HDIR)\OCI_IIOP.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    --no-virtual-inheritance $(IDLDIR)\OB\OCI_IIOP.idl & \
	    move OCI_IIOP_fwd.h $(HDIR) & \
	    move OCI_IIOP.h $(HDIR)

IMRState.cpp $(HDIR)/IMRState.h $(HDIR)/IMRState_fwd.h: \
		$(IDLDIR)/OB/IMRState.idl
	if exist $(IDL) \
	    del IMRState.cpp & \
	    del $(HDIR)\IMRState_fwd.h & \
	    del $(HDIR)\IMRState.h & \
	    del $(IMRDIR)\IMRState_skel.cpp & \
	    del $(HDIR)\IMRState_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd $(IDLDIR)\OB\IMRState.idl & \
	    move IMRState_fwd.h $(HDIR) & \
	    move IMRState.h $(HDIR) & \
	    move IMRState_skel.h $(HDIR) & \
	    move IMRState_skel.cpp $(IMRDIR)

OADProcessEndpoint.cpp $(HDIR)/OADProcessEndpoint.h \
	$(HDIR)/OADProcessEndpoint_fwd.h: \
		$(IDLDIR)/OB/OADProcessEndpoint.idl
	if exist $(IDL) \
	    del OADProcessEndpoint.cpp & \
	    del $(HDIR)\OADProcessEndpoint_fwd.h & \
	    del $(HDIR)\OADProcessEndpoint.h & \
	    del OADProcessEndpoint_skel.cpp & \
	    del $(HDIR)\OADProcessEndpoint_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd \
	    $(IDLDIR)\OB\OADProcessEndpoint.idl & \
	    move OADProcessEndpoint_fwd.h $(HDIR) & \
	    move OADProcessEndpoint.h $(HDIR) & \
	    move OADProcessEndpoint_skel.h $(HDIR)

IMRTypes.cpp $(HDIR)/IMRTypes.h: \
		$(IDLDIR)/OB/IMRTypes.idl
	if exist $(IDL) \
	    del IMRTypes.cpp & \
	    del $(HDIR)\IMRTypes.h & \
	    del IMRTypes_skel.cpp & \
	    del $(HDIR)\IMRTypes_skel.h & \
	    $(IDL) $(ALL_IDLFLAGS) --no-type-codes \
	    $(IDLDIR)\OB\IMRTypes.idl & \
	    move IMRTypes.h $(HDIR) & \
	    move IMRTypes_skel.h $(HDIR) & \
	    del IMRTypes_skel.cpp

Dispatch.cpp $(HDIR)/Dispatch.h $(HDIR)/Dispatch_fwd.h: \
		$(IDLDIR)/OB/Dispatch.idl
	if exist $(IDL) \
	    del Dispatch.cpp & \
	    del $(HDIR)\Dispatch_fwd.h & \
	    del $(HDIR)\Dispatch.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\Dispatch.idl & \
	    move Dispatch_fwd.h $(HDIR) & \
	    move Dispatch.h $(HDIR)

BootManager.cpp $(HDIR)/BootManager.h $(HDIR)/BootManager_fwd.h: \
		$(IDLDIR)/OB/BootManager.idl
	if exist $(IDL) \
	    del BootManager.cpp & \
	    del $(HDIR)\BootManager_fwd.h & \
	    del $(HDIR)\BootManager.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\BootManager.idl & \
	    move BootManager_fwd.h $(HDIR) & \
	    move BootManager.h $(HDIR)

PICommon.cpp $(HDIR)/PICommon.h $(HDIR)/PICommon_fwd.h: \
		$(IDLDIR)/OB/PICommon.idl
	if exist $(IDL) \
	    del PICommon.cpp & \
	    del $(HDIR)\PICommon_fwd.h & \
	    del $(HDIR)\PICommon.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\PICommon.idl & \
	    move PICommon_fwd.h $(HDIR) & \
	    move PICommon.h $(HDIR)

PIRequest.cpp $(HDIR)/PIRequest.h $(HDIR)/PIRequest_fwd.h: \
		$(IDLDIR)/OB/PIRequest.idl
	if exist $(IDL) \
	    del PIRequest.cpp & \
	    del $(HDIR)\PIRequest_fwd.h & \
	    del $(HDIR)\PIRequest.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\PIRequest.idl & \
	    move PIRequest_fwd.h $(HDIR) & \
	    move PIRequest.h $(HDIR)

PIClient.cpp $(HDIR)/PIClient.h $(HDIR)/PIClient_fwd.h: \
		$(IDLDIR)/OB/PIClient.idl
	if exist $(IDL) \
	    del PIClient.cpp & \
	    del $(HDIR)\PIClient_fwd.h & \
	    del $(HDIR)\PIClient.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\PIClient.idl & \
	    move PIClient_fwd.h $(HDIR) & \
	    move PIClient.h $(HDIR)

PIServer.cpp $(HDIR)/PIServer.h $(HDIR)/PIServer_fwd.h: \
		$(IDLDIR)/OB/PIServer.idl
	if exist $(IDL) \
	    del PIServer.cpp & \
	    del $(HDIR)\PIServer_fwd.h & \
	    del $(HDIR)\PIServer.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\PIServer.idl & \
	    move PIServer_fwd.h $(HDIR) & \
	    move PIServer.h $(HDIR)

PIPolicy.cpp $(HDIR)/PIPolicy.h $(HDIR)/PIPolicy_fwd.h: \
		$(IDLDIR)/OB/PIPolicy.idl
	if exist $(IDL) \
	    del PIPolicy.cpp & \
	    del $(HDIR)\PIPolicy_fwd.h & \
	    del $(HDIR)\PIPolicy.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\PIPolicy.idl & \
	    move PIPolicy_fwd.h $(HDIR) & \
	    move PIPolicy.h $(HDIR)

PIIOR.cpp $(HDIR)/PIIOR.h $(HDIR)/PIIOR_fwd.h: \
		$(IDLDIR)/OB/PIIOR.idl
	if exist $(IDL) \
	    del PIIOR.cpp & \
	    del $(HDIR)\PIIOR_fwd.h & \
	    del $(HDIR)\PIIOR.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\PIIOR.idl & \
	    move PIIOR_fwd.h $(HDIR) & \
	    move PIIOR.h $(HDIR)

PIORBInit.cpp $(HDIR)/PIORBInit.h $(HDIR)/PIORBInit_fwd.h: \
		$(IDLDIR)/OB/PIORBInit.idl
	if exist $(IDL) \
	    del PIORBInit.cpp & \
	    del $(HDIR)\PIORBInit_fwd.h & \
	    del $(HDIR)\PIORBInit.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\PIORBInit.idl & \
	    move PIORBInit_fwd.h $(HDIR) & \
	    move PIORBInit.h $(HDIR)

OBORBInit.cpp $(HDIR)/OBORBInit.h $(HDIR)/OBORBInit_fwd.h: \
		$(IDLDIR)/OB/OBORBInit.idl
	if exist $(IDL) \
	    del OBORBInit.cpp & \
	    del $(HDIR)\OBORBInit_fwd.h & \
	    del $(HDIR)\OBORBInit.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\OBORBInit.idl & \
	    move OBORBInit_fwd.h $(HDIR) & \
	    move OBORBInit.h $(HDIR)

PICurrent.cpp $(HDIR)/PICurrent.h $(HDIR)/PICurrent_fwd.h: \
		$(IDLDIR)/OB/PICurrent.idl
	if exist $(IDL) \
	    del PICurrent.cpp & \
	    del $(HDIR)\PICurrent_fwd.h & \
	    del $(HDIR)\PICurrent.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\PICurrent.idl & \
	    move PICurrent_fwd.h $(HDIR) & \
	    move PICurrent.h $(HDIR)

PI.cpp $(HDIR)/PI.h $(HDIR)/PI_fwd.h: $(IDLDIR)/OB/PI.idl
	if exist $(IDL) \
	    del PI.cpp & \
	    del $(HDIR)\PI_fwd.h & \
	    del $(HDIR)\PI.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\PI.idl & \
	    move PI_fwd.h $(HDIR) & \
	    move PI.h $(HDIR)

Dynamic.cpp $(HDIR)/Dynamic.h $(HDIR)/Dynamic_fwd.h: \
		$(IDLDIR)/OB/Dynamic.idl
	if exist $(IDL) \
	    del Dynamic.cpp & \
	    del $(HDIR)\Dynamic_fwd.h & \
	    del $(HDIR)\Dynamic.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\Dynamic.idl & \
	    move Dynamic_fwd.h $(HDIR) & \
	    move Dynamic.h $(HDIR)

TimeBase.cpp $(HDIR)/TimeBase.h $(HDIR)/TimeBase_fwd.h: \
		$(IDLDIR)/OB/TimeBase.idl
	if exist $(IDL) \
	    del TimeBase.cpp & \
	    del $(HDIR)\TimeBase_fwd.h & \
	    del $(HDIR)\TimeBase.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd \
	    $(IDLDIR)\OB\TimeBase.idl & \
	    move TimeBase_fwd.h $(HDIR) & \
	    move TimeBase.h $(HDIR)

Messaging.cpp $(HDIR)/Messaging.h $(HDIR)/Messaging_fwd.h: \
		$(IDLDIR)/OB/Messaging.idl
	if exist $(IDL) \
	    del Messaging.cpp & \
	    del $(HDIR)\Messaging_fwd.h & \
	    del $(HDIR)\Messaging.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\Messaging.idl & \
	    move Messaging_fwd.h $(HDIR) & \
	    move Messaging.h $(HDIR)

Codec.cpp $(HDIR)/Codec.h $(HDIR)/Codec_fwd.h: \
		$(IDLDIR)/OB/Codec.idl
	if exist $(IDL) \
	    del Codec.cpp & \
	    del $(HDIR)\Codec_fwd.h & \
	    del $(HDIR)\Codec.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --locality-constrained \
	    $(IDLDIR)\OB\Codec.idl & \
	    move Codec_fwd.h $(HDIR) & \
	    move Codec.h $(HDIR)

ServiceInfo.cpp $(HDIR)/ServiceInfo.h $(HDIR)/ServiceInfo_fwd.h: \
		$(IDLDIR)/OB/ServiceInfo.idl
	if exist $(IDL) \
	    del ServiceInfo.cpp & \
	    del $(HDIR)\ServiceInfo_fwd.h & \
	    del $(HDIR)\ServiceInfo.h & \
	    $(IDL) $(ALL_IDLFLAGS) --fwd --no-skeletons \
	    $(IDLDIR)\OB\ServiceInfo.idl & \
	    move ServiceInfo_fwd.h $(HDIR) & \
	    move ServiceInfo.h $(HDIR)

install:: all
	copy $(NAME) $(libdir)
	if exist $(PDB_NAME) \
	copy $(PDB_NAME) $(libdir)

!if "$(DLL)" == "yes"

DLL_PDB = $(DLL_NAME:.dll=.pdb)

install:: all
	copy $(DLL_NAME) $(libdir)
	copy $(EXP_NAME) $(libdir)
	if exist $(DLL_PDB) \
	copy $(DLL_PDB) $(libdir)

clean::
	if exist $(DLL_PDB) del $(DLL_PDB)

!endif

clean::
	-del $(DLL_NAME) $(EXP_NAME) $(DEF_NAME) $(PDB_NAME)

min:: all

install_min:: install

!include .windep
