// **********************************************************************
//
// Copyright (c) 1999
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef MESSAGING_IMPL_H
#define MESSAGING_IMPL_H

#include <OB/Object.h>
#include <OB/Except.h>
#include <OB/Messaging.h>

namespace Messaging
{

class SyncScopePolicy_impl : public SyncScopePolicy
{
    //
    // Hide copy-constructor and assignment operator
    //
    SyncScopePolicy_impl(const SyncScopePolicy_impl&);
    void operator=(const SyncScopePolicy_impl&);

    SyncScope value_;

public:

    SyncScopePolicy_impl(SyncScope);
    ~SyncScopePolicy_impl();

    virtual SyncScope synchronization()
        throw(CORBA::SystemException);

    virtual CORBA::PolicyType policy_type()
        throw(CORBA::SystemException);
    virtual CORBA::Policy_ptr copy()
        throw(CORBA::SystemException);
    virtual void destroy()
        throw(CORBA::SystemException);
};

} // End of namespace Messaging

#endif
