// **********************************************************************
//
// Copyright (c) 1999
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_ORB_POLICY_MANAGER_IMPL_H
#define OB_ORB_POLICY_MANAGER_IMPL_H

#include <OB/Object.h>
#include <OB/Except.h>
#include <OB/Policy.h>

namespace OBCORBA
{

class ORB_impl; // For the friend declaration

} // End namespace OBCORBA

namespace CORBA
{

class ORBPolicyManager_impl : public PolicyManager OB_COMMA_MUTEX
{
    //
    // Hide copy-constructor and assignment operator
    //
    ORBPolicyManager_impl(const ORBPolicyManager_impl&);
    void operator=(const ORBPolicyManager_impl&);

    PolicyList& policies_;

    ORBPolicyManager_impl(PolicyList&);
    friend class ::OBCORBA::ORB_impl; // ORB_impl may create ORBPolicyManagers

public:

    ~ORBPolicyManager_impl();

    virtual Policy_ptr get_policy_override(PolicyType)
        throw(SystemException);

    virtual PolicyList*
    get_specific_policy_overrides(const PolicyTypeSeq&)
        throw(SystemException);

    virtual PolicyList* get_all_policy_overrides()
        throw(SystemException);

    virtual void add_policy_overrides(const PolicyList&)
        throw(PolicyManager::InvalidPolicies,
              SystemException);

    virtual void remove_policy_overrides(const PolicyTypeSeq&)
        throw(SystemException);

    virtual void replace_all_policy_overrides(const PolicyList&)
        throw(PolicyManager::InvalidPolicies,
              SystemException);
};

} // End of namespace CORBA

#endif
