// **********************************************************************
//
// Copyright (c) 1999
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef POA_LOCATOR_H
#define POA_LOCATOR_H

#include <OB/POAInterface_fwd.h>

#include <OB/Object.h>
#include <OB/StubImpl.h>
#include <OB/Hashtable.h>
#include <OB/IMRTypes.h>
 
namespace OB
{

//
// Other declarations
// 
struct ObjectKeyData;

} // End namespace OB

namespace OBPortableServer
{

//
// Set of associated POAs
//
struct POANameHasher
{
    static CORBA::ULong hash(const IMR::POAName&);
    static bool comp(const IMR::POAName&, const IMR::POAName&);
};
typedef OB::Hashtable< IMR::POAName , PortableServer::POA_var,
		       POANameHasher, OB::LockStrategyNull > POAHashTable;

class POALocator OB_COLON_RECURSIVE_MUTEX
{
    POAHashTable* poas_;

public:

    POALocator();
    ~POALocator();

    //
    // Locate a POA
    //
    PortableServer::POA_ptr locate(const OB::ObjectKeyData&)
        throw(OB::LocationForward, CORBA::SystemException);

    //
    // Add a POA
    //
    void add(PortableServer::POA_ptr, const IMR::POAName&);

    //
    // Remove a POA
    //
    void remove(const IMR::POAName&);
};

} // End namespace OBPortableServer

#endif
