// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef UTIL_H
#define UTIL_H

//
// A hashtable for comments
//
typedef OB::Hashtable< CORBA::RepositoryId_var, CORBA::String_var,
    OB::StringHasher, OB::LockStrategyNull > IdlStringHash;

//
// Convert strings with escape sequences
//
void IdlAddEscapes(char*&, bool);
char* IdlAddEscapes(const wchar_t*, bool);
bool IdlRemoveEscapes(char*&, bool); // Returns false if string contains \0
bool IdlRemoveEscapes(const char*, wchar_t*&, bool); // ditto

//
// Compare two strings. The return value has the usual strcmp()-like
// semantics. The global variable IdlCaseSensitive determines whether
// case is considered during the comparison.
//
extern bool IdlCaseSensitive;
int IdlStringCompare(const char*, const char*);

#endif
