# **********************************************************************
#
# Copyright (c) 1999
# Object Oriented Concepts, Inc.
# Billerica, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

LIB_NAME	= $(top_srcdir)\lib\obtestmain$(LIBSUFFIX).lib
PDB_NAME        = $(top_srcdir)\lib\obtestmain$(LIBSUFFIX).pdb
SERVER_NAME	= server.exe
CLIENT_NAME	= client.exe
COLLOCATED_NAME	= collocated.exe

!ifndef BUILD_EXE
TARGETS		= $(LIB_NAME) 
PDB_FLAGS       = /Fd$(PDB_NAME)
!else
TARGETS 	= $(SERVER_NAME) \
		  $(CLIENT_NAME) \
		  $(COLLOCATED_NAME)

PDB_FILES	= $(TARGETS:.exe=.pdb) \
	          $(PDB_NAME)
!endif

!include $(top_srcdir)\config\Make.rules.mak

LIB_OBJS	= TestIntf.obj \
		  TestIntf_skel.obj \
		  TestIntf_2_3_NoLongDouble.obj \
		  TestIntf_2_3_NoLongDouble_skel.obj \
		  TestIntf_2_3.obj \
		  TestIntf_2_3_skel.obj \
		  Test_impl.obj \
		  TestDSI_impl.obj \
		  TestStub.obj \
		  TestStubContext.obj \
		  TestStubException.obj \
		  TestStubTimeout.obj \
		  TestDII.obj \
		  TestDIIContext.obj \
		  TestDIIException.obj \
		  ReactorInit.obj \
		  Server.obj \
		  Client.obj

SERVER_OBJS	= ServerMain.obj

CLIENT_OBJS	= ClientMain.obj

COLLOCATED_OBJS	= CollocatedMain.obj

ALL_CXXFLAGS	= $(CXXFLAGS) $(PDB_FLAGS)
ALL_CPPFLAGS	= /I. /I..\include $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_LIBS	= $(LIB_NAME) $(OB_LIBS) $(LIBS)

$(LIB_NAME): $(LIB_OBJS)
	-del $@
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

$(SERVER_NAME): $(SERVER_OBJS) $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(SERVER_OBJS) $(ALL_LIBS)

$(CLIENT_NAME): $(CLIENT_OBJS) $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(CLIENT_OBJS) $(ALL_LIBS)

$(COLLOCATED_NAME): $(COLLOCATED_OBJS) $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(COLLOCATED_OBJS) $(ALL_LIBS)

TestIntf.cpp TestIntf.h: TestIntf.idl
	-del TestIntf.cpp TestIntf.h
	$(IDL) --tie TestIntf.idl

TestIntf_skel.cpp TestIntf_skel.h TestIntf_tie.h TestIntf_skel_tie.h: 
	TestIntf.cpp

TestIntf_2_3_NoLongDouble.cpp TestIntf_2_3_NoLongDouble.h: \
	TestIntf_2_3_NoLongDouble.idl
	-del TestIntf_2_3_NoLongDouble.cpp TestIntf_2_3_NoLongDouble.h
	$(IDL) --tie TestIntf_2_3_NoLongDouble.idl

TestIntf_2_3_NoLongDouble_skel.cpp TestIntf_2_3_NoLongDouble_skel.h \
	TestIntf_2_3_NoLongDouble_tie.h TestIntf_2_3_NoLongDouble_skel_tie.h: 
	TestIntf_2_3_NoLongDouble.cpp

TestIntf_2_3.cpp TestIntf_2_3.h: TestIntf_2_3.idl
	-del TestIntf_2_3.cpp TestIntf_2_3.h
	$(IDL) --tie TestIntf_2_3.idl

TestIntf_2_3_skel.cpp TestIntf_2_3_skel.h TestIntf_2_3_tie.h \
	TestIntf_2_3_skel_tie.h: 
	TestIntf_2_3.cpp

!ifndef BUILD_EXE
install:: all

$(EVERYTHING)::
	$(MAKE) /f Makefile.mak BUILD_EXE=1 $@
!else
install:: all
	copy $(LIB_NAME) $(libdir)
	if exist $(PDB_NAME) copy $(PDB_NAME) $(libdir)
!endif


!include .windep
