// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <stdlib.h>

using namespace CORBA;
using namespace PortableServer;

POA_ptr
TestUtil_GetRootPOA(ORB_ptr orb)
{
    Object_var obj;

    try
    {
        obj = orb -> resolve_initial_references("RootPOA");
    }
    catch(const ORB::InvalidName&)
    {
	OB_CERR << "Error: can't resolve `RootPOA'" << OB_ENDL;
	exit(1);
    }

    if(is_nil(obj))
    {
	OB_CERR << "Error: `RootPOA' is a nil object reference"
		     << OB_ENDL;
	exit(1);
    }

    POA_var root = POA::_narrow(obj);

    if(is_nil(root))
    {
	OB_CERR << "Error: `RootPOA' is not a POA object reference"
		     << OB_ENDL;
	exit(1);
    }

    return root._retn();
}

bool TestUtil_Compare(const ObjectId& id1, const ObjectId& id2)
{
    return (id1.length() == id2.length() &&
            memcmp(id1.get_buffer(), id2.get_buffer(), id1.length()) == 0);
}
