// **********************************************************************
//
// Copyright (c) 2000
// Object Oriented Concepts, Inc.
// Billerica, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

using namespace CORBA;

int
run(ORB_ptr orb, int argc, char* argv[])
{
    try
    {
        OB_COUT << "Testing constants... " << OB_FLUSH;
        extern void TestConst();
        TestConst();
        OB_COUT << "OK!" << OB_ENDL;

        OB_COUT << "Testing TypeCode type... " << OB_FLUSH;
        extern void TestTypeCode();
        TestTypeCode();
        OB_COUT << "OK!" << OB_ENDL;
        
        OB_COUT << "Testing any type... " << OB_FLUSH;
        extern void TestAny();
        TestAny();
        OB_COUT << "OK!" << OB_ENDL;

        OB_COUT << "Testing DynAny type... " << OB_FLUSH;
        extern void TestDynAny(ORB_ptr);
        TestDynAny(orb);
        OB_COUT << "OK!" << OB_ENDL;

        OB_COUT << "Testing some union types... " << OB_FLUSH;
        extern void TestUnion();
        TestUnion();
        OB_COUT << "OK!" << OB_ENDL;

        OB_COUT << "Testing fixed type... " << OB_FLUSH;
        extern void TestFixed();
        TestFixed();
        OB_COUT << "OK!" << OB_ENDL;

	OB_COUT << "Testing sequence types..." << OB_FLUSH;
	extern void TestSequence();
	TestSequence();
	OB_COUT << "OK!" << OB_ENDL;
    }
    catch(const Exception& ex)
    {
	OB_CERR << ex << OB_ENDL;
        return 1;
    }

    return 0;
}

int
main(int argc, char* argv[])
{
    int status = EXIT_SUCCESS;
    ORB_var orb;

    try
    {
        //
        // Create ORB
        //
        orb = ORB_init(argc, argv);

	//
	// Run the test
	//
	status = run(orb, argc, argv);
    }
    catch(const Exception& ex)
    {
        OB_CERR << ex << OB_ENDL;
        status = EXIT_SUCCESS;
    }

    if(!is_nil(orb))
    {
	try
	{
	    orb -> destroy();
	}
	catch(const Exception& ex)
	{
	    OB_CERR << ex << OB_ENDL;
	    status = EXIT_FAILURE;
	}
    }

    return status;
}
